Download SFML 2.5.1

On Windows, choosing 32 or 64-bit libraries should be based on which platform you want to compile for, not which OS you have. Indeed, you can perfectly compile and run a 32-bit program on a 64-bit Windows. So you'll most likely want to target 32-bit platforms, to have the largest possible audience. Choose 64-bit packages only if you have good reasons.
The compiler versions have to match 100%!
Here are links to the specific MinGW compiler versions used to build the provided packages:
TDM 5.1.0 (32-bit), MinGW Builds 7.3.0 (32-bit), MinGW Builds 7.3.0 (64-bit)
Visual C++ 15 (2017) - 32-bitDownload16.3 MB Visual C++ 15 (2017) - 64-bitDownload18.0 MB
Visual C++ 14 (2015) - 32-bitDownload18.0 MB Visual C++ 14 (2015) - 64-bitDownload19.9 MB
Visual C++ 12 (2013) - 32-bitDownload18.3 MB Visual C++ 12 (2013) - 64-bitDownload20.3 MB
GCC 5.1.0 TDM (SJLJ) - Code::Blocks - 32-bitDownload14.1 MB
GCC 7.3.0 MinGW (DW2) - 32-bitDownload15.5 MB GCC 7.3.0 MinGW (SEH) - 64-bitDownload16.5 MB
On Linux, if you have a 64-bit OS then you have the 64-bit toolchain installed by default. Compiling for 32-bit is possible, but you have to install specific packages and/or use specific compiler options to do so. So downloading the 64-bit libraries is the easiest solution if you're on a 64-bit Linux.
If you require a 32-bit build of SFML you'll have to build it yourself.
It's recommended to use the SFML version from your package manager (if recent enough) or build from source to prevent incompatibilities.
Linux GCC - 64-bitDownload2.21 MB
macOS Clang - 64-bit (OS X 10.7+, compatible with C++11 and libc++)Download5.50 MB
macOS libraries are only compatible with 64-bit systems.
All Source codeDownload22.2 MB
HTML DocumentationDownload1.42 MB